#include <GUIConstantsEx.au3>
#include <EditConstants.au3>
#include <AutoItConstants.au3>
#include <MsgBoxConstants.au3>
#include <GuiComboBox.au3>
#include "CommInterface.au3"
#include <Timers.au3>

$arm = 0           ; variable to coordinate between scan button and Deviare callback
$numberOfScans = 5 ; we stop after 40
$doScan = 0        ; used as a signal by Deviare callback, so that the GUI thread knows to run another scan

$hGUI = GUICreate("DAVID Laserscanner 5 Turntable Automator",500,120)
$x_coordinate = GUICtrlCreateInput("120", 220, 20, 90, 20, $ES_NUMBER )
$y_coordinate = GUICtrlCreateInput("345", 220, 45, 90, 20, $ES_NUMBER )
GUICtrlCreateLabel("X coordinate of Scan button in DAVID:", 20, 20+2)
GUICtrlCreateLabel("Y coordinate of Scan button in DAVID:", 20, 50+2)
GUICtrlCreateLabel("COM Port:", 20, 80+2)
$comboBoxCOM  = GUICtrlCreateCombo("", 220, 70, 90, 20)

For $i = 1 To 100
    $sVar = RegEnumVal("HKEY_LOCAL_MACHINE\HARDWARE\DEVICEMAP\SERIALCOMM", $i)
    If @error <> 0 Then ExitLoop
    Local $sVar2 = RegRead("HKEY_LOCAL_MACHINE\HARDWARE\DEVICEMAP\SERIALCOMM", $sVar)
    $isCom = StringInStr($sVar2,"COM") ; check for presence of the substring "COM" in the key
    if ($isCom <> 0) then
      GUICtrlSetData($comboBoxCOM,$sVar2)
      _GUICtrlComboBox_SetEditText($comboBoxCOM,$sVar2)
    EndIf
Next

Local $idScan = GUICtrlCreateButton("Scan", 350, 20, 100, 32)
Local $idStop = GUICtrlCreateButton("Abort", 350, 57, 100, 32)
GUISetState(@SW_SHOW, $hGUI) ; Display the GUI.

$comObject = ObjCreate("DeviareCOM.NktSpyMgr")   ; Create an COM object to access the Deviare interface
$comObject.Initialize
$eventObject=ObjEvent($comObject,"Deviare2_","DNktSpyMgrEvents")  ; events from comObject are now passed to eventObject

While 1  ; Loop until the user exits.
 Switch GUIGetMsg()
  Case $GUI_EVENT_CLOSE
    ExitLoop
  Case  $idScan
    $numberOfScans = 0
    Scan()
  Case  $idStop
    $numberOfScans = 5  		;modificare anche qui il numero scansioni
    $doScan = 0
    $arm = 0
 EndSwitch
 $position = MouseGetPos () ; read current mouse position
 Tooltip ($position[0] & ", " & $position[1]) ; make a tool tip displaying current mouse position
 Sleep (50) ; limit the CPU load by restricting the number of GUIGetMsg calls per second
 if $doScan = 1 Then
     $doScan = 0
     Scan()
 EndIf
WEnd

Func Scan ()

    $numberOfScans = $numberOfScans + 1
    $str = GUICtrlRead($comboBoxCOM)    ; get value of COM port from ComboBox
    $ret = StringRegExp($str, '\d+', 1) ; strip the 'COM' from the string

    Local $iPort = $ret[0]
    Local $iBaud = 9600
    Local $iParity = 0
    Local $iByteSize = 8
    Local $iStopBits = 2	; note: some hardware does not support 1.5 stop bits. provato con 2!

    ; it is tempting to write 1 for stop bits but:
    ; ONESTOPBIT    0    1 stop bit.
    ; ONE5STOPBITS  1    1.5 stop bits.
    ; TWOSTOPBITS   2    2 stop bits.

    Local $sCommand = "2" & @CRLF
    Local $hFile = _CommAPI_OpenCOMPort($iPort, $iBaud, $iParity, $iByteSize, $iStopBits)

    If $hFile = 0 Then
        MsgBox(64, "Error in _CommAPI_OpenCOMPort" & @error, _WinAPI_GetLastErrorMessage())
    Else
      _CommAPI_ClearCommError($hFile)
      If @error Then
        MsgBox(32, "Error in _CommAPI_ClearCommError" & @error, _WinAPI_GetLastErrorMessage())
      EndIf
      _CommAPI_PurgeComm($hFile)
      If @error Then
        MsgBox(32, "Error in _CommAPI_PurgeComm" & @error, _WinAPI_GetLastErrorMessage())
      EndIf
      _CommAPI_TransmitString($hFile, $sCommand)
      If @error Then
        MsgBox(32, "Error in _CommAPI_TransmitString" & @error, _WinAPI_GetLastErrorMessage())
      EndIf
      Local $sResult = _CommAPI_ReceiveString($hFile, 5000)

      If @error Then
       Switch @error
        Case 0
            MsgBox(64, "Result5", SetError(@error, @ScriptLineNumber))
        Case -1
            MsgBox(32, "Error5", _WinAPI_GetLastErrorMessage())
        Case -2
            MsgBox(32, "Timeout5", SetError(@error, @ScriptLineNumber))
        Case Else
            MsgBox(32, "Error5", "Error " & @error & " in line " & $sResult)
       EndSwitch
      EndIf
      _CommAPI_ClosePort($hFile)

      If @error Then
       Switch @error
        Case 0
            MsgBox(64, "Result6", SetError(@error, @ScriptLineNumber))
        Case -1
            MsgBox(32, "Error6", _WinAPI_GetLastErrorMessage())
        Case -2
            MsgBox(32, "Timeout6", SetError(@error, @ScriptLineNumber))
        Case Else
            MsgBox(32, "Error6", "Error " & @error & " in line " & $sResult)
       EndSwitch
      EndIf

    EndIf

    Sleep (3000)   ; now that we sent a turn command, lets wait a moment to give the table time to settle

                   ; also, on slower computers it sometimes takes a little longer before the scan button is enabled again

    MouseClick($MOUSE_CLICK_LEFT, GUICtrlRead($x_coordinate), GUICtrlRead($y_coordinate), 1)

    Sleep (2000)   ; David acts the same at the beginning and the end of the scan. wait before arming the callback

    $arm = 1       ; arm the callback

EndFunc

Volatile Func Deviare2_OnProcessStarted($process)

; for reference on the proc object: http://www.nektra.com/products/deviare-api-hook-windows/doc-v2/interface_i_nkt_process.html

  if ($process.Name == "HP3DScan5.exe") then

    $hook = $comObject.CreateHook("kernel32.dll!CreateFileW", 0)

    $hook.Attach($process, True)

    $hook.Hook()

  EndIf

EndFunc

Volatile Func Deviare2_OnFunctionCalled($hook, $process, $callInfo)

  $Params = $callInfo.Params ; get the params member of the callInfo structure

  $First = $Params.First     ; get the first parameter passed to CreateFile

  $present = StringInStr($First.value,"font") ; check for presence of the substring "font" in the parameter.

  if ($present <> 0) then

      if $arm = 1 Then        ; we are waiting for the end of a scan and have reached it

          $arm = 0

          if $numberOfScans < 5 Then

            ConsoleWrite ( $Params.First.name & $Params.First.value & @CRLF )

            $doScan = 1 ;signal GUI to scan

          EndIf

      EndIf

  EndIf

EndFunc

; User's COM error function. Will be called if COM error occurs

; from https://www.autoitscript.com/forum/topic/134615-the-requested-action-with-this-object-has-failed/

$oMyError = ObjEvent("AutoIt.Error","MyErrFunc")    ; Initialize a COM error handler

Func MyErrFunc()

  Msgbox(0,"AutoItCOM Test","We intercepted a COM Error !"    & @CRLF  & @CRLF & _

   "err.description is: " & @TAB & $oMyError.description  & @CRLF & _
   "err.windescription:"   & @TAB & $oMyError.windescription & @CRLF & _
   "err.number is: "       & @TAB & hex($oMyError.number,8)  & @CRLF & _
   "err.lastdllerror is: "   & @TAB & $oMyError.lastdllerror   & @CRLF & _
   "err.scriptline is: "   & @TAB & $oMyError.scriptline   & @CRLF & _
   "err.source is: "       & @TAB & $oMyError.source       & @CRLF & _
   "err.helpfile is: "       & @TAB & $oMyError.helpfile     & @CRLF & _
   "err.helpcontext is: " & @TAB & $oMyError.helpcontext _
   )

Endfunc